%% Exercise 2, Sheet 9

M = load_shape('cat0.vert');

%% PART 1, eigendecomposition

evecs = cotan_LB(M, 20);

figure,

for i=1:20
   subplot(4,5,i), plot_scalar_map(M, evecs(:,i)), axis off, 
   title(sprintf('Eigenfunction %i', i)),
end

%% PART 2, heat diffusion

n_evecs = 100;
[evecs, evals] = cotan_LB(M, n_evecs);

% init heat, 1 heat at vertex k
k = 1000;
u = zeros(M.n,1);
u(k) = 1;

% diffuse

d = evecs' * M.M * u;
D = repmat(d', M.n, 1);

figure,

diff0 =  evecs * (evecs' * (M.M * u));
maxi = max(diff0);
mini = min(diff0);
plot_scalar_map(M, diff0), axis off, caxis([min(diff0), max(diff0)]),
pause(0.1),

for t=0.01:0.5:100
    lam = exp(-t*evals);
    E = repmat(lam', M.n, 1);
    diff = sum(D .* E .* evecs, 2);
    plot_scalar_map(M, diff), axis off, caxis([min(diff0), max(diff0)]),
    pause(0.05),
end


%% PART 3, heat kernel signature

N = load_shape('cat6.vert');

n_evecs = 50;
[M.evecs, M.evals] = cotan_LB(M, n_evecs);
[N.evecs, N.evals] = cotan_LB(N, n_evecs);

figure,
subplot(1,2,1), plot_scalar_map(M, calc_HKS(M, n_evecs, 0.1)), axis off,
subplot(1,2,2), plot_scalar_map(N, calc_HKS(N, n_evecs, 0.1)), axis off,

